#
# Conference Bus protocol
# msg : hdr body
# hdr : srcname/srcpid dstname/dstpid
# body : string
# srcname, dstname: string, with "all" reserved for broadcast.
# srcpid, dstpid: pid or "all".
#
proc cbSend { dstspec msg } {
	global confbus cbAppName
	$confbus send "$cbAppName/[pid] $dstspec $msg"
}

proc cbBroadcast msg {
	global confbus cbAppName
	$confbus send "$cbAppName/[pid] all/all $msg"
}

proc processHdr h {
	global cbAppName    	
	set srcspec [lindex $h 0]

	set dst [split [lindex $h 1] /]
     	set dstname [lindex $dst 0]
      	set dstpid [lindex $dst 1]
	
	if { ($dstname == "all" || \
		($dstname == "$cbAppName" &&  \
		($dstpid == [pid] || $dstpid == "all"))) } {
		return $srcspec
	}
	return ""
}

proc confbusHandler { cb msg } {
	if { [llength $msg] < 2 } {
		return
	}

	set hdr [lrange $msg 0 1]
	set srcspec [processHdr $hdr]
	if { $srcspec == "" } {
		# Not for us
		return 
	}
	
	global cb_dispatch
	set body [lrange $msg 2 end]
	if { [llength $body] < 1 } {
		return
	}
	
	set class [lindex $body 0]
	if ![info exists cb_dispatch($class)] {
		return
	}
	set proc $cb_dispatch($class)
	set formals [info args $proc]
	set actuals [lrange $body 1 end]
	if { [expr [llength $actuals]+1] != [llength $formals] } {
		return		
	}
	eval "$proc $srcspec $actuals"
}
