# Derived from cf-network.tcl.

proc cb_crypt_set { srcspec sname var val } {
    switch $var {
	key {
	    crypt_set $sname $val
	}
	clear {
	    crypt_clear $sname
	}
	default {
	    cb_set $srcspec $sname $var $val
	}
    }
}

proc crypt_format key {
    set k [string first / $key]
    if { $k < 0 } {
	set fmt DES1
    } else {
	set fmt [string range $key 0 [expr $k - 1]]
	set key [string range $key [expr $k + 1] end]
    }
    return "$fmt $key"
}

proc crypt_set { sname key } {
    global V
    set L [crypt_format $key ]
    set fmt [lindex $L 0]
    set key [lindex $L 1]
    set dc data-crypt:$fmt
    set cc ctrl-crypt:$fmt
    if ![info exists V($sname,$dc)] {
	set crypt [new crypt $fmt/data]
	if { $crypt == "" } {
	    puts "no $fmt enryption support"
	    return -1
	}
	set V($sname,$dc) $crypt
	set V($sname,$cc) [new crypt $fmt/ctrl]
    }
    if [$V($sname,$dc) key $key] {
	$V($sname,$cc) key $key
	$V($sname,data-net) crypt $V($sname,$dc)
	$V($sname,ctrl-net) crypt $V($sname,$cc)
	return 0
    } else {
	puts "your key is cryptographically weak"
	crypt_clear $sname
	return -1
    }
}

proc crypt_clear sname {
    global V
    $V($sname,data-net) crypt ""
    $V($sname,ctrl-net) crypt ""
}
