#ifndef vgw_encoder_h
#define vgw_encoder_h

#include "config.h"

class Transmitter;

struct VideoFrame {
public:
        inline VideoFrame(u_int32_t ts, const u_int8_t* bp, int w, int h, 
			  int dec, u_int8_t* crvec) :
                ts_(ts), bp_(bp), width_(w), height_(h), decimation_(dec),
		crvec_(crvec) {}
        u_int32_t ts_;
        const u_int8_t* bp_;
        int width_;
        int height_;
	int decimation_;	/* XXX */
	const u_int8_t* crvec_;
};

struct AudioFrame {
public:
        inline AudioFrame(u_int32_t ts, const u_int8_t* bp, int len) :
                ts_(ts), bp_(bp), len_(len) {}
        u_int32_t ts_;
        const u_int8_t* bp_;
	int len_;
};

class VideoEncoder : public TclObject {
 public:
	virtual int consume(const VideoFrame* vf, Transmitter& tx) = 0;
	virtual int framesize(int inw, int inh, int& outw, int& outh) const 
		= 0;
	inline void color(int v) { color_ = v; }
 protected:
	int color_;
};

class AudioEncoder : public TclObject {
 public:
	virtual int consume(const AudioFrame* af, Transmitter& tx) = 0;
};

#endif /* vgw_encoder_h */
