/*
 * Copyright (c) 1995 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 * @(#) $Header: /home/barad-dur/b/users/elan/src/vgw/vgw/ipad/RCS/ipadchan.h,v 1.2 1995/11/22 03:28:25 elan Exp $ (UC Berkeley)
 */

#ifndef vgw_ipadchan_h
#define vgw_ipadchan_h

#include "net.h"

class IpadChannel : public Network {
 public:
	IpadChannel(int);
	IpadChannel();
	void send_codebook_entries(u_int, u_int, u_int, u_char *);
	void send_video_data(int, int, int, u_char *, int);
	
	inline void pad_id(int p) { pad_id_ = p; }
	inline int pad_id() { return pad_id_; }
 private:
	int	pad_id_;
	void	*ipad_conn_;	/* This is void so that we do not need infopad
				 * includes for this include file 
				 */
};

#endif
	
	
