/* 
 * tkAppInit.c --
 *
 *	Provides a default version of the Tcl_AppInit procedure for
 *	use in wish and similar Tk-based applications.
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

#ifndef lint
static char rcsid[] = "$Header: /home/barad-dur/b/users/elan/src/rtpgw/engines/RCS/tk-compat.cc,v 1.8 1996/05/23 01:48:02 elan Exp $ SPRITE (Berkeley)";
#endif /* not lint */

#include <sys/param.h>
#include <sys/time.h>
#include <tcl.h>

extern "C" {
/*XXX total hack. to get tk options with no tcl */
struct option {
	char attr[80];
	char val[80];
	int pri;
	option* next;
};
static struct option *allopt;

void
Tk_AddOption(void*, char* attr, char *val, int pri)
{
	option* o = new option;
	strcpy(o->attr, attr);
	strcpy(o->val, val);
	o->pri = pri;
	o->next = allopt;
	allopt = o;
}

char*
Tk_GetOption(void*, char* attr, char* program)
{
	int pri = -1;
	option* o = 0;
	char buf[256];
	sprintf(buf, "%s.%s", program, attr);
	for (option* p = allopt; p != 0; p = p->next) {
		if (strcmp(buf, p->attr) == 0 && p->pri > pri) {
			o = p;
			pri = o->pri;
		}
	}
        if (o != 0)
		return (o->val);
	else
		return (0);
}
}


