# Derived from ui-util.tcl and cf-network.tcl from vic.

proc mk.entry { w action text } {
	entry $w.entry -relief raised -borderwidth 1 -exportselection 1 \
		-font [option get . entryFont RtpgwUI]
	global entryTab
	set entryTab($w.entry:action) $action
	set entryTab($w.entry:value) $text
	$w.entry insert 0 $text
}

proc toggleKey { w sname } {
        global V entryTab
	if $V($sname,encrypt) {
		crypt_set $sname $entryTab($w.entry:value)
	} else {
		crypt_clear $sname
	}
}

proc disableKeyEditor w {
	global entryTab
	$w.button configure -state disabled
	set entryTab($w.entry:value) ""
}

proc enableKeyEditor w {
	global entryTab
	$w.button configure -state normal
	set entryTab($w.entry:value) [$w.entry get]
}

proc updateKeyA { w key } {
    updateKey $w A $key
}

proc updateKeyB { w key } {
    updateKey $w B $key
}

proc updateKey { w sname key } {
	set w [winfo parent $w]
	set key [string trim $key]
	if { $key == "" } {
		crypt_clear $sname
		disableKeyEditor $w
	} elseif { [crypt_set $sname $key] < 0 } {
		# XXX Need to check this in UI.
		# illegal key - clear it the entry
		disableKeyEditor $w
	} else {
		enableKeyEditor $w
	}
}

proc mk.key { w sname } {
	global V
	frame $w.key
	checkbutton $w.key.button -text Key: -relief flat -font [smallfont] \
		-command "toggleKey $w.key $sname" \
		-variable V($sname,encrypt)  -disabledforeground gray40 \
		-highlightthickness 0
	
	mk.entry $w.key updateKey$sname $V($sname,key)

	if !$V($sname,encrypt) {
		$w.key.button configure -state disabled
	}
	
	pack $w.key.button -side left
	pack $w.key.entry -side left -fill x -expand 1
}

proc crypt_set { sname key } {
	global V
	cb_send "cb_crypt_set $sname key $key"
	set V($sname,encrypt) 1
	# XXX
	return 1
}

proc crypt_clear sname {
	global V
	cb_send "cb_crypt_set $sname clear 0"
	set V($sname,encrypt) 0
}
