#
# Copyright (c) 1995 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the Computer Systems
#       Engineering Group at Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /home/barad-dur/b/users/elan/src/vgw/ui/RCS/switcher.tcl,v 1.7 1995/12/12 22:54:08 elan Exp $ (UC Berkeley)
#
proc mkSrcBWController { w src } {
    	global config 
    	set f [smallfont]

	set config(pathnames,switch,$src) $w.switch

    	# XXX For mono
    	radiobutton $w.switch -text "Transcode" -font $f -value "$src" \
			-variable config(srcswitch) -command source_switch \
			-relief groove -borderwidth 1 -highlightthickness 1
    	$w.switch deselect
	set config(pathnames,transcodebutton,$src) $w.switch
	pack $w.switch -side top -expand 1
}

proc source_switch {} {
	global config srcinfo

	set cursrc $config(srcswitch)
	# Give all the bandwidth to the selected source
	set sname $srcinfo($cursrc,sname)
	foreach src $config(active_list) {
		if { $srcinfo($src,sname) == $sname && $src != $cursrc } then {
			set srcinfo($src,perbw) 0
			setmaxbps $src 0
		}
	}
	set srcinfo($cursrc,perbw) 100
	set oname [outsess $srcinfo($src,sname)]
	setmaxbps $cursrc $config($oname,totbw)	
}

proc activate { srcspec src name addr sname info transcoder } {
    	global config currow curcol
    	if { [llength $config(active_list)] == 0 } then {
		pack forget .top.label
		build.table .top
		pack .top.table -fill both -anchor n
	}
	lappend config(active_list) $src

	set s [build.src $src $name $addr $sname $info $transcoder]

	# Select the first stream to transcode if we are using a switcher
	if { [llength $config(active_list)] == 1 } then {
		$config(pathnames,transcodebutton,$src) select
		source_switch
	}
	set config(pathnames,srcs,$src) $s

	if { $transcoder == "pass-thru" } then {
		set osess [outsess $sname]	
		if {$config($osess,RC) == 0} then {
			srcBWstate $src alldisabled
		} else {
			srcBWstate $src disabled
		}
	}   	

	set w $config(table)
	blt_table $w $s $currow,$curcol -anchor n -fill x
	blt_table column $w configure all -resize both
	blt_table row $w configure all -resize none
	bump
	
}

proc srcBWstate { src state } {
	global config srcinfo

	if { [info exists config(pathnames,switch,$src)] == 0 } then {
		return
	}

	if { $state == "alldisabled" } then {
		set f1 [option get . disabledForeground VgwUI]
		set s "disabled"
	} elseif { $state == "disabled" } {
		set f1 [option get . disabledForeground VgwUI]
		set s "normal"
	} else {
		set f1 [option get . foreground VgwUI]
		set s "normal"
	}
	
	$config(pathnames,switch,$src) configure -state $s

	set p $config(pathnames,srcs,$src)	
	$p.l.rates.ifps configure -foreground $f1
	$p.l.rates.ofps configure -foreground $f1
}

proc src_switch addr {
	global config srcinfo
	foreach s $config(active_list) {
		if { $srcinfo($s,addr) == $addr } then {
			break
		}
	}

	set sname $srcinfo($s,sname)
	set osess [outsess $sname]
	# If not a rate controlled session or switching turned off for the 
	# session - do nothing.
	if { $config($osess,RC) == 0 || $config($osess,switching) == "off" } {
		return
	}

	$config(pathnames,switch,$s) invoke
}
	
proc setsrcbw {s b} {}
